Difference between revisions of "Extra python modules"

From FreeCAD Documentation
Jump to: navigation, search
(Marked this version for translation)
 
(2 intermediate revisions by 2 users not shown)
Line 2: Line 2:
 
<translate>
 
<translate>
 
<!--T:122-->
 
<!--T:122-->
{{docnav|Localisation|Source documentation}}
+
{{docnav
 +
|[[Localisation|Localisation]]
 +
|[[Source documentation|Source documentation]]
 +
}}
  
 
<!--T:1-->
 
<!--T:1-->
Line 27: Line 30:
  
 
==== MacOSX ==== <!--T:8-->
 
==== MacOSX ==== <!--T:8-->
PyQt on Mac can be installed via homebrew or port. See [[Compile on MacOS#Install_Dependencies]] for more information.   
+
PyQt on Mac can be installed via homebrew or port. See [[Compile on MacOS#Install_Dependencies|Install dependencies]] for more information.   
  
 
=== Usage === <!--T:9-->
 
=== Usage === <!--T:9-->
 
Once it is installed, you can check that everything is working by typing in FreeCAD python console:
 
Once it is installed, you can check that everything is working by typing in FreeCAD python console:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 36: Line 40:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:10-->
 
<!--T:10-->
 
To access the FreeCAD interface, type :
 
To access the FreeCAD interface, type :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 44: Line 50:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:11-->
 
<!--T:11-->
 
Now you can start to explore the interface with the dir() command. You can add new elements, like a custom widget, with commands like :
 
Now you can start to explore the interface with the dir() command. You can add new elements, like a custom widget, with commands like :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 51: Line 59:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:12-->
 
<!--T:12-->
 
Working with Unicode :
 
Working with Unicode :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 58: Line 68:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:13-->
 
<!--T:13-->
 
Working with QFileDialog and OpenFileName :
 
Working with QFileDialog and OpenFileName :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 67: Line 79:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:14-->
 
<!--T:14-->
 
Working with QFileDialog and SaveFileName :
 
Working with QFileDialog and SaveFileName :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 76: Line 90:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
===Example of transition from PyQt4 and PySide=== <!--T:15-->
 
===Example of transition from PyQt4 and PySide=== <!--T:15-->
  
 
<!--T:16-->
 
<!--T:16-->
 
PS: these examples of errors were found in the transition from PyQt4 to PySide and these corrections were made, other solutions are certainly available with the examples above
 
PS: these examples of errors were found in the transition from PyQt4 to PySide and these corrections were made, other solutions are certainly available with the examples above
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 100: Line 116:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:17-->
 
<!--T:17-->
 
To access the FreeCAD interface, type :
 
To access the FreeCAD interface, type :
 
You can add new elements, like a custom widget, with commands like :
 
You can add new elements, like a custom widget, with commands like :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 117: Line 135:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:18-->
 
<!--T:18-->
 
Working with Unicode :  
 
Working with Unicode :  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 127: Line 147:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:19-->
 
<!--T:19-->
 
Working with QFileDialog and OpenFileName :
 
Working with QFileDialog and OpenFileName :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 138: Line 160:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:20-->
 
<!--T:20-->
 
Working with QFileDialog and SaveFileName :
 
Working with QFileDialog and SaveFileName :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 149: Line 173:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:21-->
 
<!--T:21-->
 
The MessageBox:
 
The MessageBox:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 163: Line 189:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:22-->
 
<!--T:22-->
 
Working with setProperty (PyQt4) and setValue (PySide)
 
Working with setProperty (PyQt4) and setValue (PySide)
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 170: Line 198:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:23-->
 
<!--T:23-->
 
replace with :
 
replace with :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 177: Line 207:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:24-->
 
<!--T:24-->
 
Working with setToolTip
 
Working with setToolTip
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 184: Line 216:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:25-->
 
<!--T:25-->
 
replace with :
 
replace with :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 191: Line 225:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:26-->
 
<!--T:26-->
 
or :
 
or :
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 232: Line 268:
 
<!--T:36-->
 
<!--T:36-->
 
The best way to compile pivy easily is to grab the debian source package for pivy and make a package with debuild. It is the same source code from the official pivy site, but the debian people made several bug-fixing additions. It also compiles fine on ubuntu karmic: http://packages.debian.org/squeeze/python-pivy download the .orig.gz and the .diff.gz file, then unzip both, then apply the .diff to the source: go to the unzipped pivy source folder, and apply the .diff patch:
 
The best way to compile pivy easily is to grab the debian source package for pivy and make a package with debuild. It is the same source code from the official pivy site, but the debian people made several bug-fixing additions. It also compiles fine on ubuntu karmic: http://packages.debian.org/squeeze/python-pivy download the .orig.gz and the .diff.gz file, then unzip both, then apply the .diff to the source: go to the unzipped pivy source folder, and apply the .diff patch:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 237: Line 274:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:37-->
 
<!--T:37-->
 
then
 
then
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 244: Line 283:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:38-->
 
<!--T:38-->
 
to have pivy properly built into an official installable package. Then, just install the package with gdebi.
 
to have pivy properly built into an official installable package. Then, just install the package with gdebi.
Line 249: Line 289:
 
==== Other linux distributions ==== <!--T:39-->
 
==== Other linux distributions ==== <!--T:39-->
 
First get the latest sources from the [http://pivy.coin3d.org/mercurial/ project's repository]:
 
First get the latest sources from the [http://pivy.coin3d.org/mercurial/ project's repository]:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 254: Line 295:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:40-->
 
<!--T:40-->
 
As of March 2012, the latest version is Pivy-0.5.
 
As of March 2012, the latest version is Pivy-0.5.
Line 259: Line 301:
 
<!--T:41-->
 
<!--T:41-->
 
Then you need a tool called SWIG to generate the C++ code for the Python bindings. Pivy-0.5 reports that it has only been tested with SWIG 1.3.31, 1.3.33, 1.3.35, and 1.3.40. So you can download a source tarball for one of these old versions from [http://www.swig.org http://www.swig.org]. Then unpack it and from a command line do (as root):
 
Then you need a tool called SWIG to generate the C++ code for the Python bindings. Pivy-0.5 reports that it has only been tested with SWIG 1.3.31, 1.3.33, 1.3.35, and 1.3.40. So you can download a source tarball for one of these old versions from [http://www.swig.org http://www.swig.org]. Then unpack it and from a command line do (as root):
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 266: Line 309:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:42-->
 
<!--T:42-->
 
It takes just a few seconds to build.  
 
It takes just a few seconds to build.  
Line 274: Line 318:
 
<!--T:44-->
 
<!--T:44-->
 
After that go to the pivy sources and call  
 
After that go to the pivy sources and call  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 279: Line 324:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:45-->
 
<!--T:45-->
 
which creates the source files.  Note that build can produce thousands of warnings, but hopefully there will be no errors.
 
which creates the source files.  Note that build can produce thousands of warnings, but hopefully there will be no errors.
Line 287: Line 333:
 
<!--T:47-->
 
<!--T:47-->
 
After that, install by issuing (as root):
 
After that, install by issuing (as root):
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 292: Line 339:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:48-->
 
<!--T:48-->
 
That's it, pivy is installed.
 
That's it, pivy is installed.
Line 300: Line 348:
 
<!--T:50-->
 
<!--T:50-->
 
As for linux, get the latest source:
 
As for linux, get the latest source:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 305: Line 354:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:51-->
 
<!--T:51-->
 
If you don't have hg, you can get it from MacPorts:
 
If you don't have hg, you can get it from MacPorts:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 312: Line 363:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:52-->
 
<!--T:52-->
 
Then, as above you need SWIG.  It should be a matter of:
 
Then, as above you need SWIG.  It should be a matter of:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 319: Line 372:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:53-->
 
<!--T:53-->
 
I found I needed also:
 
I found I needed also:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 326: Line 381:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:54-->
 
<!--T:54-->
 
As of March 2012, MacPorts SWIG is version 2.0.4.  As noted above for linux, you might be better off downloading an older version.  SWIG 2.0.4 seems to have a bug that stops Pivy building.  See first message in this digest: https://sourceforge.net/mailarchive/message.php?msg_id=28114815
 
As of March 2012, MacPorts SWIG is version 2.0.4.  As noted above for linux, you might be better off downloading an older version.  SWIG 2.0.4 seems to have a bug that stops Pivy building.  See first message in this digest: https://sourceforge.net/mailarchive/message.php?msg_id=28114815
Line 331: Line 387:
 
<!--T:55-->
 
<!--T:55-->
 
This can be corrected by editing the 2 source locations to add dereferences: *arg4, *arg5 in place of arg4, arg5.  Now Pivy should build:
 
This can be corrected by editing the 2 source locations to add dereferences: *arg4, *arg5 in place of arg4, arg5.  Now Pivy should build:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 337: Line 394:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
==== Windows ==== <!--T:56-->
 
==== Windows ==== <!--T:56-->
 
Assuming you are using Visual Studio 2005 or later you should open a command prompt with 'Visual Studio 2005 Command prompt' from the Tools menu.
 
Assuming you are using Visual Studio 2005 or later you should open a command prompt with 'Visual Studio 2005 Command prompt' from the Tools menu.
 
If the Python interpreter is not yet in the system path do
 
If the Python interpreter is not yet in the system path do
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 345: Line 404:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:57-->
 
<!--T:57-->
 
To get pivy working you should get the latest sources from the project's repository:
 
To get pivy working you should get the latest sources from the project's repository:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 352: Line 413:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:58-->
 
<!--T:58-->
 
Then you need a tool called SWIG to generate the C++ code for the Python bindings. It is recommended to use version 1.3.25 of SWIG, not the latest version, because at the moment pivy will only function correctly with 1.3.25. Download the binaries for 1.3.25 from [http://www.swig.org http://www.swig.org]. Then unpack it and from the command line add it to the system path
 
Then you need a tool called SWIG to generate the C++ code for the Python bindings. It is recommended to use version 1.3.25 of SWIG, not the latest version, because at the moment pivy will only function correctly with 1.3.25. Download the binaries for 1.3.25 from [http://www.swig.org http://www.swig.org]. Then unpack it and from the command line add it to the system path
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 359: Line 422:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:59-->
 
<!--T:59-->
 
and set COINDIR to the appropriate path
 
and set COINDIR to the appropriate path
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 366: Line 431:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:60-->
 
<!--T:60-->
 
On Windows the pivy config file expects SoWin instead of SoQt as default. I didn't find an obvious way to build with SoQt, so I modified the file setup.py directly.
 
On Windows the pivy config file expects SoWin instead of SoQt as default. I didn't find an obvious way to build with SoQt, so I modified the file setup.py directly.
Line 372: Line 438:
 
<!--T:61-->
 
<!--T:61-->
 
After that go to the pivy sources and call  
 
After that go to the pivy sources and call  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 377: Line 444:
 
}}
 
}}
 
<translate>  
 
<translate>  
 +
 
<!--T:62-->
 
<!--T:62-->
 
which creates the source files. You may run into a compiler error several header files couldn't be found. In this case adjust the INCLUDE variable
 
which creates the source files. You may run into a compiler error several header files couldn't be found. In this case adjust the INCLUDE variable
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 384: Line 453:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:63-->
 
<!--T:63-->
 
and if the SoQt headers are not in the same place as the Coin headers also
 
and if the SoQt headers are not in the same place as the Coin headers also
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 391: Line 462:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:64-->
 
<!--T:64-->
 
and finally the Qt headers
 
and finally the Qt headers
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 398: Line 471:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:65-->
 
<!--T:65-->
 
If you are using the Express Edition of Visual Studio you may get a python keyerror exception.
 
If you are using the Express Edition of Visual Studio you may get a python keyerror exception.
Line 404: Line 478:
 
<!--T:66-->
 
<!--T:66-->
 
Go to line 122 and replace the line
 
Go to line 122 and replace the line
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 409: Line 484:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:67-->
 
<!--T:67-->
 
with
 
with
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 416: Line 493:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:68-->
 
<!--T:68-->
 
Then retry again.
 
Then retry again.
 
If you get a second error like  
 
If you get a second error like  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 424: Line 503:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:69-->
 
<!--T:69-->
 
you must also replace line 128
 
you must also replace line 128
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 431: Line 512:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:70-->
 
<!--T:70-->
 
with
 
with
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 438: Line 521:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:71-->
 
<!--T:71-->
 
Retry once again. If you get again an error like
 
Retry once again. If you get again an error like
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 445: Line 530:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:72-->
 
<!--T:72-->
 
then you should check the environment variables DISTUTILS_USE_SDK and MSSDK with
 
then you should check the environment variables DISTUTILS_USE_SDK and MSSDK with
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 453: Line 540:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:73-->
 
<!--T:73-->
 
If not yet set then just set it e.g. to 1
 
If not yet set then just set it e.g. to 1
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 461: Line 550:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:74-->
 
<!--T:74-->
 
Now, you may run into a compiler error where a 'const char*' cannot be converted in a 'char*'. To fix that you just need to write a 'const' before in the appropriate lines. There are six lines to fix.  
 
Now, you may run into a compiler error where a 'const char*' cannot be converted in a 'char*'. To fix that you just need to write a 'const' before in the appropriate lines. There are six lines to fix.  
Line 467: Line 557:
 
=== Usage === <!--T:75-->
 
=== Usage === <!--T:75-->
 
To check if Pivy is correctly installed:
 
To check if Pivy is correctly installed:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 472: Line 563:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:76-->
 
<!--T:76-->
 
To have Pivy access the FreeCAD scenegraph do the following:  
 
To have Pivy access the FreeCAD scenegraph do the following:  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 483: Line 576:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:77-->
 
<!--T:77-->
 
You can now explore the FCSceneGraph with the dir() command.
 
You can now explore the FCSceneGraph with the dir() command.
Line 509: Line 603:
 
==== Linux ==== <!--T:84-->
 
==== Linux ==== <!--T:84-->
 
In either case, you'll need the following packages already installed on your system:
 
In either case, you'll need the following packages already installed on your system:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 516: Line 611:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
===== From the git repository ===== <!--T:85-->
 
===== From the git repository ===== <!--T:85-->
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 524: Line 621:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
===== With easy_install ===== <!--T:86-->
 
===== With easy_install ===== <!--T:86-->
 
Assuming you have a complete python installation already, the easy_install utility should be present already:
 
Assuming you have a complete python installation already, the easy_install utility should be present already:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 531: Line 630:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:87-->
 
<!--T:87-->
 
You can check if pycollada was correctly installed by issuing in a python console:
 
You can check if pycollada was correctly installed by issuing in a python console:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 538: Line 639:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:88-->
 
<!--T:88-->
 
If it returns nothing (no error message), then all is OK
 
If it returns nothing (no error message), then all is OK
Line 553: Line 655:
 
<!--T:94-->
 
<!--T:94-->
 
If you need to install pip:
 
If you need to install pip:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 558: Line 661:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:95-->
 
<!--T:95-->
 
Install pycollada:
 
Install pycollada:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 565: Line 670:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:96-->
 
<!--T:96-->
 
If you are using a binary version of FreeCAD, you can tell pip to install pycollada into the site-packages inside FreeCAD.app:
 
If you are using a binary version of FreeCAD, you can tell pip to install pycollada into the site-packages inside FreeCAD.app:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
 
$ pip install --target="/Applications/FreeCAD.app/Contents/lib/python2.7/site-packages" pycollada
 
$ pip install --target="/Applications/FreeCAD.app/Contents/lib/python2.7/site-packages" pycollada
 
}}
 
}}
 +
<translate>
 +
 +
<!--T:126-->
 
or after downloading the pycollada code
 
or after downloading the pycollada code
 +
 +
</translate>
 
{{Code|code=
 
{{Code|code=
 
$ export PYTHONPATH=/Applications/FreeCAD\ 0.16.6706.app/Contents/lib/python2.7/site-packages:$PYTHONPATH
 
$ export PYTHONPATH=/Applications/FreeCAD\ 0.16.6706.app/Contents/lib/python2.7/site-packages:$PYTHONPATH
Line 593: Line 705:
 
==== Linux ==== <!--T:101-->
 
==== Linux ==== <!--T:101-->
 
You will need a couple of development packages installed on your system in order to compile ifcopenshell:
 
You will need a couple of development packages installed on your system in order to compile ifcopenshell:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 600: Line 713:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:102-->
 
<!--T:102-->
 
but since FreeCAD requires all of them too, if you can compile FreeCAD, you won't need any extra dependency to compile IfcOpenShell.
 
but since FreeCAD requires all of them too, if you can compile FreeCAD, you won't need any extra dependency to compile IfcOpenShell.
Line 605: Line 719:
 
<!--T:103-->
 
<!--T:103-->
 
Grab the latest source code from here:
 
Grab the latest source code from here:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 610: Line 725:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:104-->
 
<!--T:104-->
 
The build process is very easy:
 
The build process is very easy:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 619: Line 736:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:105-->
 
<!--T:105-->
 
or, if you are using oce instead of opencascade:
 
or, if you are using oce instead of opencascade:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 626: Line 745:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:106-->
 
<!--T:106-->
 
Since ifcopenshell is made primarily for Blender, it uses python3 by default. To use it inside FreeCAD, you need to compile it against the same version of python that is used by FreeCAD. So you might need to force the python version with additional cmake parameters (adjust the python version to yours):  
 
Since ifcopenshell is made primarily for Blender, it uses python3 by default. To use it inside FreeCAD, you need to compile it against the same version of python that is used by FreeCAD. So you might need to force the python version with additional cmake parameters (adjust the python version to yours):  
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 633: Line 754:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:107-->
 
<!--T:107-->
 
Then:
 
Then:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 641: Line 764:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:108-->
 
<!--T:108-->
 
You can check that ifcopenshell was correctly installed by issuing in a python console:
 
You can check that ifcopenshell was correctly installed by issuing in a python console:
 +
 
</translate>
 
</translate>
 
{{Code|code=
 
{{Code|code=
Line 648: Line 773:
 
}}
 
}}
 
<translate>
 
<translate>
 +
 
<!--T:109-->
 
<!--T:109-->
 
If it returns nothing (no error message), then all is OK
 
If it returns nothing (no error message), then all is OK
Line 682: Line 808:
  
 
<!--T:118-->
 
<!--T:118-->
{{docnav|Localisation|Source documentation}}
+
{{docnav
 +
|[[Localisation|Localisation]]
 +
|[[Source documentation|Source documentation]]
 +
}}
  
 
<!--T:124-->
 
<!--T:124-->

Latest revision as of 10:56, 14 November 2019

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe

This page lists several additional python modules or other pieces of software that can be downloaded freely from the internet, and add functionality to your FreeCAD installation.

PySide (previously PyQt4)

PySide (previously PyQt) is required by several modules of FreeCAD to access FreeCAD's Qt interface. It is already bundled in the windows verison of FreeCAD, and is usually installed automatically by FreeCAD on Linux, when installing from official repositories. If those modules (Draft, Arch, etc) are enabled after FreeCAD is installed, it means PySide (previously PyQt) is already there, and you don't need to do anything more.

Note: FreeCAD progressively moved away from PyQt after version 0.13, in favour of PySide, which does exactly the same job but has a license (LGPL) more compatible with FreeCAD.

Installation

Linux

The simplest way to install PySide is through your distribution's package manager. On Debian/Ubuntu systems, the package name is generally python-PySide, while on RPM-based systems it is named pyside. The necessary dependencies (Qt and SIP) will be taken care of automatically.

Windows

The program can be downloaded from http://qt-project.org/wiki/Category:LanguageBindings::PySide::Downloads . You'll need to install the Qt and SIP libraries before installing PySide (to be documented).

MacOSX

PyQt on Mac can be installed via homebrew or port. See Install dependencies for more information.

Usage

Once it is installed, you can check that everything is working by typing in FreeCAD python console:

import PySide

To access the FreeCAD interface, type :

from PySide import QtCore,QtGui
FreeCADWindow = FreeCADGui.getMainWindow()

Now you can start to explore the interface with the dir() command. You can add new elements, like a custom widget, with commands like :

FreeCADWindow.addDockWidget(QtCore.Qt.RghtDockWidgetArea,my_custom_widget)

Working with Unicode :

text = text.encode('utf-8')

Working with QFileDialog and OpenFileName :

path = FreeCAD.ConfigGet("AppHomePath")
#path = FreeCAD.ConfigGet("UserAppData")
OpenName, Filter = PySide.QtGui.QFileDialog.getOpenFileName(None, "Read a txt file", path, "*.txt")

Working with QFileDialog and SaveFileName :

path = FreeCAD.ConfigGet("AppHomePath")
#path = FreeCAD.ConfigGet("UserAppData")
SaveName, Filter = PySide.QtGui.QFileDialog.getSaveFileName(None, "Save a file txt", path, "*.txt")

Example of transition from PyQt4 and PySide

PS: these examples of errors were found in the transition from PyQt4 to PySide and these corrections were made, other solutions are certainly available with the examples above

try:
    import PyQt4                                        # PyQt4
    from PyQt4 import QtGui ,QtCore                     # PyQt4
    from PyQt4.QtGui import QComboBox                   # PyQt4
    from PyQt4.QtGui import QMessageBox                 # PyQt4
    from PyQt4.QtGui import QTableWidget, QApplication  # PyQt4
    from PyQt4.QtGui import *                           # PyQt4
    from PyQt4.QtCore import *                          # PyQt4
except Exception:
    import PySide                                       # PySide
    from PySide import QtGui ,QtCore                    # PySide
    from PySide.QtGui import QComboBox                  # PySide
    from PySide.QtGui import QMessageBox                # PySide
    from PySide.QtGui import QTableWidget, QApplication # PySide
    from PySide.QtGui import *                          # PySide
    from PySide.QtCore import *                         # PySide

To access the FreeCAD interface, type : You can add new elements, like a custom widget, with commands like :

myNewFreeCADWidget = QtGui.QDockWidget()          # create a new dockwidget
myNewFreeCADWidget.ui = Ui_MainWindow()           # myWidget_Ui()             # load the Ui script
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
try:
    app = QtGui.qApp                              # PyQt4 # the active qt window, = the freecad window since we are inside it
    FCmw = app.activeWindow()                     # PyQt4 # the active qt window, = the freecad window since we are inside it
    FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window
except Exception:
    FCmw = FreeCADGui.getMainWindow()             # PySide # the active qt window, = the freecad window since we are inside it 
    FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window

Working with Unicode :

try:
    text = unicode(text, 'ISO-8859-1').encode('UTF-8')  # PyQt4
except Exception:
    text = text.encode('utf-8')                         # PySide

Working with QFileDialog and OpenFileName :

OpenName = ""
try:
    OpenName = QFileDialog.getOpenFileName(None,QString.fromLocal8Bit("Lire un fichier FCInfo ou txt"),path,"*.FCInfo *.txt") # PyQt4
except Exception:
    OpenName, Filter = PySide.QtGui.QFileDialog.getOpenFileName(None, "Lire un fichier FCInfo ou txt", path, "*.FCInfo *.txt")#PySide

Working with QFileDialog and SaveFileName :

SaveName = ""
try:
    SaveName = QFileDialog.getSaveFileName(None,QString.fromLocal8Bit("Sauver un fichier FCInfo"),path,"*.FCInfo") # PyQt4
except Exception:
    SaveName, Filter = PySide.QtGui.QFileDialog.getSaveFileName(None, "Sauver un fichier FCInfo", path, "*.FCInfo")# PySide

The MessageBox:

def errorDialog(msg):
    diag = QtGui.QMessageBox(QtGui.QMessageBox.Critical,u"Error Message",msg )
    try:
        diag.setWindowFlags(PyQt4.QtCore.Qt.WindowStaysOnTopHint) # PyQt4 # this function sets the window before
    except Exception:    
        diag.setWindowFlags(PySide.QtCore.Qt.WindowStaysOnTopHint)# PySide # this function sets the window before
#    diag.setWindowModality(QtCore.Qt.ApplicationModal)       # function has been disabled to promote "WindowStaysOnTopHint"
    diag.exec_()

Working with setProperty (PyQt4) and setValue (PySide)

self.doubleSpinBox.setProperty("value", 10.0)  # PyQt4

replace with :

self.doubleSpinBox.setValue(10.0)  # PySide

Working with setToolTip

self.doubleSpinBox.setToolTip(_translate("MainWindow", "Coordinate placement Axis Y", None))  # PyQt4

replace with :

self.doubleSpinBox.setToolTip(_fromUtf8("Coordinate placement Axis Y"))  # PySide

or :

self.doubleSpinBox.setToolTip(u"Coordinate placement Axis Y.")# PySide

Additional documentation

Some pyQt4 tutorials (including how to build interfaces with Qt Designer to use with python):

Pivy

Pivy is a needed by several modules to access the 3D view of FreeCAD. On windows, Pivy is already bundled inside the FreeCAD installer, and on Linux it is usually automatically installed when you install FreeCAD from an official repository. On MacOSX, unfortunately, you will need to compile pivy yourself.

Installation

Prerequisites

I believe before compiling Pivy you will want to have Coin and SoQt installed.

I found for building on Mac it was sufficient to install the Coin3 binary package. Attempting to install coin from MacPorts was problematic: tried to add a lot of X Windows packages and ultimately crashed with a script error.

For Fedora I found an RPM with Coin3.

SoQt compiled from source fine on Mac and Linux.

Debian & Ubuntu

Starting with Debian Squeeze and Ubuntu Lucid, pivy will be available directly from the official repositories, saving us a lot of hassle. In the meantime, you can either download one of the packages we made (for debian and ubuntu karmic) availables on the Download pages, or compile it yourself.

The best way to compile pivy easily is to grab the debian source package for pivy and make a package with debuild. It is the same source code from the official pivy site, but the debian people made several bug-fixing additions. It also compiles fine on ubuntu karmic: http://packages.debian.org/squeeze/python-pivy download the .orig.gz and the .diff.gz file, then unzip both, then apply the .diff to the source: go to the unzipped pivy source folder, and apply the .diff patch:

patch -p1 < ../pivy_0.5.0~svn765-2.diff

then

debuild

to have pivy properly built into an official installable package. Then, just install the package with gdebi.

Other linux distributions

First get the latest sources from the project's repository:

hg clone http://hg.sim.no/Pivy/default Pivy

As of March 2012, the latest version is Pivy-0.5.

Then you need a tool called SWIG to generate the C++ code for the Python bindings. Pivy-0.5 reports that it has only been tested with SWIG 1.3.31, 1.3.33, 1.3.35, and 1.3.40. So you can download a source tarball for one of these old versions from http://www.swig.org. Then unpack it and from a command line do (as root):

./configure
make
make install (or checkinstall if you use it)

It takes just a few seconds to build.

Alternatively, you can try building with a more recent SWIG. As of March 2012, a typical repository version is 2.0.4. Pivy has a minor compile problem with SWIG 2.0.4 on Mac OS (see below) but seems to build fine on Fedora Core 15.

After that go to the pivy sources and call

python setup.py build

which creates the source files. Note that build can produce thousands of warnings, but hopefully there will be no errors.

This is probably obsolete, but you may run into a compiler error where a 'const char*' cannot be converted in a 'char*'. To fix that you just need to write a 'const' before in the appropriate lines. There are six lines to fix.

After that, install by issuing (as root):

python setup.py install (or checkinstall python setup.py install)

That's it, pivy is installed.

Mac OS

These instructions may not be complete. Something close to this worked for OS 10.7 as of March 2012. I use MacPorts for repositories, but other options should also work.

As for linux, get the latest source:

hg clone http://hg.sim.no/Pivy/default Pivy

If you don't have hg, you can get it from MacPorts:

port install mercurial

Then, as above you need SWIG. It should be a matter of:

port install swig

I found I needed also:

port install swig-python

As of March 2012, MacPorts SWIG is version 2.0.4. As noted above for linux, you might be better off downloading an older version. SWIG 2.0.4 seems to have a bug that stops Pivy building. See first message in this digest: https://sourceforge.net/mailarchive/message.php?msg_id=28114815

This can be corrected by editing the 2 source locations to add dereferences: *arg4, *arg5 in place of arg4, arg5. Now Pivy should build:

python setup.py build
sudo python setup.py install

Windows

Assuming you are using Visual Studio 2005 or later you should open a command prompt with 'Visual Studio 2005 Command prompt' from the Tools menu. If the Python interpreter is not yet in the system path do

set PATH=path_to_python_2.5;%PATH%

To get pivy working you should get the latest sources from the project's repository:

svn co https://svn.coin3d.org/repos/Pivy/trunk Pivy

Then you need a tool called SWIG to generate the C++ code for the Python bindings. It is recommended to use version 1.3.25 of SWIG, not the latest version, because at the moment pivy will only function correctly with 1.3.25. Download the binaries for 1.3.25 from http://www.swig.org. Then unpack it and from the command line add it to the system path

set PATH=path_to_swig_1.3.25;%PATH%

and set COINDIR to the appropriate path

set COINDIR=path_to_coin

On Windows the pivy config file expects SoWin instead of SoQt as default. I didn't find an obvious way to build with SoQt, so I modified the file setup.py directly. In line 200 just remove the part 'sowin' : ('gui._sowin', 'sowin-config', 'pivy.gui.') (do not remove the closing parenthesis).

After that go to the pivy sources and call

python setup.py build


which creates the source files. You may run into a compiler error several header files couldn't be found. In this case adjust the INCLUDE variable

set INCLUDE=%INCLUDE%;path_to_coin_include_dir

and if the SoQt headers are not in the same place as the Coin headers also

set INCLUDE=%INCLUDE%;path_to_soqt_include_dir

and finally the Qt headers

set INCLUDE=%INCLUDE%;path_to_qt4\include\Qt

If you are using the Express Edition of Visual Studio you may get a python keyerror exception. In this case you have to modify a few things in msvccompiler.py located in your python installation.

Go to line 122 and replace the line

vsbase = r"Software\Microsoft\VisualStudio\%0.1f" % version

with

vsbase = r"Software\Microsoft\VCExpress\%0.1f" % version

Then retry again. If you get a second error like

error: Python was built with Visual Studio 2003;...

you must also replace line 128

self.set_macro("FrameworkSDKDir", net, "sdkinstallrootv1.1")

with

self.set_macro("FrameworkSDKDir", net, "sdkinstallrootv2.0")

Retry once again. If you get again an error like

error: Python was built with Visual Studio version 8.0, and extensions need to be built with the same version of the compiler, but it isn't installed.

then you should check the environment variables DISTUTILS_USE_SDK and MSSDK with

echo %DISTUTILS_USE_SDK%
echo %MSSDK%

If not yet set then just set it e.g. to 1

set DISTUTILS_USE_SDK=1
set MSSDK=1

Now, you may run into a compiler error where a 'const char*' cannot be converted in a 'char*'. To fix that you just need to write a 'const' before in the appropriate lines. There are six lines to fix. After that copy the generated pivy directory to a place where the python interpreter in FreeCAD can find it.

Usage

To check if Pivy is correctly installed:

import pivy

To have Pivy access the FreeCAD scenegraph do the following:

from pivy import coin
App.newDocument() # Open a document and a view 
view = Gui.ActiveDocument.ActiveView 
FCSceneGraph = view.getSceneGraph() # returns a pivy Python object that holds a SoSeparator, the main "container" of the Coin scenegraph
FCSceneGraph.addChild(coin.SoCube()) # add a box to scene

You can now explore the FCSceneGraph with the dir() command.

Additonal Documentation

Unfortunately documentation about pivy is still almost nonexistant on the net. But you might find Coin documentation useful, since pivy simply translate Coin functions, nodes and methods in python, everything keeps the same name and properties, keeping in mind the difference of syntax between C and python:

You can also look at the Draft.py file in the FreeCAD Mod/Draft folder, since it makes big use of pivy.

pyCollada

pyCollada is a python library that allow programs to read and write Collada (*.DAE) files. When pyCollada is installed on your system, FreeCAD will be able to handle importing and exporting in the Collada file format.

Installation

Pycollada is usually not yet available in linux distributions repositories, but since it is made only of python files, it doesn't require compilation, and is easy to install. You have 2 ways, or directly from the official pycollada git repository, or with the easy_install tool.

Linux

In either case, you'll need the following packages already installed on your system:

python-lxml 
python-numpy
python-dateutil
From the git repository
git clone git://github.com/pycollada/pycollada.git pycollada
cd pycollada
sudo python setup.py install
With easy_install

Assuming you have a complete python installation already, the easy_install utility should be present already:

easy_install pycollada

You can check if pycollada was correctly installed by issuing in a python console:

import collada

If it returns nothing (no error message), then all is OK

Windows

On Windows since 0.15 pycollada is included in both the FreeCAD release and developer builds so no additional steps are necessary.

Mac OS

If you are using the Homebrew build of FreeCAD you can install pycollada into your system Python using pip.

If you need to install pip:

$ sudo easy_install pip

Install pycollada:

$ sudo pip install pycollada

If you are using a binary version of FreeCAD, you can tell pip to install pycollada into the site-packages inside FreeCAD.app:

$ pip install --target="/Applications/FreeCAD.app/Contents/lib/python2.7/site-packages" pycollada

or after downloading the pycollada code

$ export PYTHONPATH=/Applications/FreeCAD\ 0.16.6706.app/Contents/lib/python2.7/site-packages:$PYTHONPATH
$ python setup.py install --prefix=/Applications/FreeCAD\ 0.16.6706.app/Contents

IfcOpenShell

IFCOpenShell is a library currently in development, that allows to import (and soon export) Industry foundation Classes (*.IFC) files. IFC is an extension to the STEP format, and is becoming the standard in BIM workflows. When ifcopenshell is correctly installed on your system, the FreeCAD Arch Module will detect it and use it to import IFC files, instead of its built-in rudimentary importer. Since ifcopenshell is based on OpenCasCade, like FreeCAD, the quality of the import is very high, producing high-quality solid geometry.

Installation

Since ifcopenshell is pretty new, you'll likely need to compile it yourself.

Linux

You will need a couple of development packages installed on your system in order to compile ifcopenshell:

liboce-*-dev
python-dev
swig

but since FreeCAD requires all of them too, if you can compile FreeCAD, you won't need any extra dependency to compile IfcOpenShell.

Grab the latest source code from here:

git clone https://github.com/IfcOpenShell/IfcOpenShell.git

The build process is very easy:

mkdir ifcopenshell-build
cd ifcopenshell-build
cmake ../IfcOpenShell/cmake

or, if you are using oce instead of opencascade:

cmake -DOCC_INCLUDE_DIR=/usr/include/oce ../ifcopenshell/cmake

Since ifcopenshell is made primarily for Blender, it uses python3 by default. To use it inside FreeCAD, you need to compile it against the same version of python that is used by FreeCAD. So you might need to force the python version with additional cmake parameters (adjust the python version to yours):

cmake -DOCC_INCLUDE_DIR=/usr/include/oce -DPYTHON_INCLUDE_DIR=/usr/include/python2.7 -DPYTHON_LIBRARY=/usr/lib/python2.7.so ../ifcopenshell/cmake

Then:

make
sudo make install

You can check that ifcopenshell was correctly installed by issuing in a python console:

import ifcopenshell

If it returns nothing (no error message), then all is OK

Windows

Note: Official FreeCAD installers obtained from the FreeCAD website/github page now contain ifcopenshell already.

Copied from the IfcOpenShell README file

Users are advised to use the Visual Studio .sln file in the win/ folder. For Windows users a prebuilt Open CASCADE version is available from the http://opencascade.org website. Download and install this version and provide the paths to the Open CASCADE header and library files to MS Visual Studio C++.

For building the IfcPython wrapper, SWIG needs to be installed. Please download the latest swigwin version from http://www.swig.org/download.html . After extracting the .zip file, please add the extracted folder to the PATH environment variable. Python needs to be installed, please provide the include and library paths to Visual Studio.

Links

Tutorial Import/Export IFC - compiling IfcOpenShell

ODA Converter (previously Teigha Converter)

The ODA Converter is a small freely available utility that allows to convert between several versions of DWG and DXF files. FreeCAD can use it to offer DWG import and export, by converting DWG files to the DXF format under the hood,then using its standard DXF importer to import the file contents. The restrictions of the DXF importer apply.

Installation

On all platforms, only by installing the appropriate package from https://www.opendesign.com/guestfiles/oda_file_converter . After installation, if the utility is not found automatically by FreeCAD, you might need to set the path to the converter executable manually, open Edit → Preferences → Import-Export → DWG and fill "Path to Teigha File Converter" appropriately.